# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from azureml._base_sdk_common.user_agent import get_user_agent
from msrest.service_client import SDKClient
from msrest import Configuration, Serializer, Deserializer
from .exceptions import wrap_api_caller_methods_with_error_handling
from .operations.assets_operations import AssetsOperations
from .operations.component_operations import ComponentOperations
from .operations.components_workspace_independent_operations import ComponentsWorkspaceIndependentOperations
from .operations.computes_operations import ComputesOperations
from .operations.computes_v2_operations import ComputesV2Operations
from .operations.data_sets_operations import DataSetsOperations
from .operations.data_sets_v2_operations import DataSetsV2Operations
from .operations.experiments_operations import ExperimentsOperations
from .operations.experiments_v2_operations import ExperimentsV2Operations
from .operations.feeds_operations import FeedsOperations
from .operations.feeds_v2_operations import FeedsV2Operations
from .operations.models_operations import ModelsOperations
from .operations.models_v2_operations import ModelsV2Operations
from .operations.module_operations import ModuleOperations
from .operations.modules_operations import ModulesOperations
from .operations.modules_v2_operations import ModulesV2Operations
from .operations.module_with_auth_operations import ModuleWithAuthOperations
from .operations.pipeline_component_operations import PipelineComponentOperations
from .operations.pipeline_drafts_operations import PipelineDraftsOperations
from .operations.pipeline_drafts_v2_operations import PipelineDraftsV2Operations
from .operations.pipeline_endpoints_operations import PipelineEndpointsOperations
from .operations.pipeline_endpoints_v2_operations import PipelineEndpointsV2Operations
from .operations.pipeline_runs_operations import PipelineRunsOperations
from .operations.pipeline_runs_v2_operations import PipelineRunsV2Operations
from .operations.published_pipelines_operations import PublishedPipelinesOperations
from .operations.published_pipelines_v2_operations import PublishedPipelinesV2Operations
from .operations.real_time_endpoints_operations import RealTimeEndpointsOperations
from .operations.real_time_endpoints_v2_operations import RealTimeEndpointsV2Operations
from .operations.runs_operations import RunsOperations
from .operations.runs_v2_operations import RunsV2Operations
from .operations.samples_operations import SamplesOperations
from .operations.samples_v2_operations import SamplesV2Operations
from . import models
from ..._version import VERSION


class DesignerServiceClientConfiguration(Configuration):
    """Configuration for DesignerServiceClient
    Note that all parameters used to create this instance are saved as instance
    attributes.

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):
        if not base_url:
            base_url = 'http://localhost'

        super(DesignerServiceClientConfiguration, self).__init__(base_url)
        # timeout for http caller to 200s since MT timeout is 180s
        # TODO: verify if this works
        self.connection.timeout = 200
        self.add_user_agent('designerserviceclient/{}'.format(VERSION))
        # add user-agent with all azureml packages and versions, eg: azureml-sdk-core/0.1.0.0 azureml-cli/0.1.0.0
        self.add_user_agent(get_user_agent())


class DesignerServiceClient(SDKClient):
    """DesignerServiceClient

    :ivar config: Configuration for client.
    :vartype config: DesignerServiceClientConfiguration

    :ivar assets: Assets operations
    :vartype assets: designer.operations.AssetsOperations
    :ivar component: Component operations
    :vartype component: designer.operations.ComponentOperations
    :ivar components_workspace_independent: ComponentsWorkspaceIndependent operations
    :vartype components_workspace_independent: designer.operations.ComponentsWorkspaceIndependentOperations
    :ivar computes: Computes operations
    :vartype computes: designer.operations.ComputesOperations
    :ivar computes_v2: ComputesV2 operations
    :vartype computes_v2: designer.operations.ComputesV2Operations
    :ivar data_sets: DataSets operations
    :vartype data_sets: designer.operations.DataSetsOperations
    :ivar data_sets_v2: DataSetsV2 operations
    :vartype data_sets_v2: designer.operations.DataSetsV2Operations
    :ivar experiments: Experiments operations
    :vartype experiments: designer.operations.ExperimentsOperations
    :ivar experiments_v2: ExperimentsV2 operations
    :vartype experiments_v2: designer.operations.ExperimentsV2Operations
    :ivar feeds: Feeds operations
    :vartype feeds: designer.operations.FeedsOperations
    :ivar feeds_v2: FeedsV2 operations
    :vartype feeds_v2: designer.operations.FeedsV2Operations
    :ivar models: Models operations
    :vartype models: designer.operations.ModelsOperations
    :ivar models_v2: ModelsV2 operations
    :vartype models_v2: designer.operations.ModelsV2Operations
    :ivar module: Module operations
    :vartype module: designer.operations.ModuleOperations
    :ivar modules: Modules operations
    :vartype modules: designer.operations.ModulesOperations
    :ivar modules_v2: ModulesV2 operations
    :vartype modules_v2: designer.operations.ModulesV2Operations
    :ivar module_with_auth: ModuleWithAuth operations
    :vartype module_with_auth: designer.operations.ModuleWithAuthOperations
    :ivar pipeline_component: PipelineComponent operations
    :vartype pipeline_component: designer.operations.PipelineComponentOperations
    :ivar pipeline_drafts: PipelineDrafts operations
    :vartype pipeline_drafts: designer.operations.PipelineDraftsOperations
    :ivar pipeline_drafts_v2: PipelineDraftsV2 operations
    :vartype pipeline_drafts_v2: designer.operations.PipelineDraftsV2Operations
    :ivar pipeline_endpoints: PipelineEndpoints operations
    :vartype pipeline_endpoints: designer.operations.PipelineEndpointsOperations
    :ivar pipeline_endpoints_v2: PipelineEndpointsV2 operations
    :vartype pipeline_endpoints_v2: designer.operations.PipelineEndpointsV2Operations
    :ivar pipeline_runs: PipelineRuns operations
    :vartype pipeline_runs: designer.operations.PipelineRunsOperations
    :ivar pipeline_runs_v2: PipelineRunsV2 operations
    :vartype pipeline_runs_v2: designer.operations.PipelineRunsV2Operations
    :ivar published_pipelines: PublishedPipelines operations
    :vartype published_pipelines: designer.operations.PublishedPipelinesOperations
    :ivar published_pipelines_v2: PublishedPipelinesV2 operations
    :vartype published_pipelines_v2: designer.operations.PublishedPipelinesV2Operations
    :ivar real_time_endpoints: RealTimeEndpoints operations
    :vartype real_time_endpoints: designer.operations.RealTimeEndpointsOperations
    :ivar real_time_endpoints_v2: RealTimeEndpointsV2 operations
    :vartype real_time_endpoints_v2: designer.operations.RealTimeEndpointsV2Operations
    :ivar runs: Runs operations
    :vartype runs: designer.operations.RunsOperations
    :ivar runs_v2: RunsV2 operations
    :vartype runs_v2: designer.operations.RunsV2Operations
    :ivar samples: Samples operations
    :vartype samples: designer.operations.SamplesOperations
    :ivar samples_v2: SamplesV2 operations
    :vartype samples_v2: designer.operations.SamplesV2Operations

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):

        self.config = DesignerServiceClientConfiguration(base_url)
        super(DesignerServiceClient, self).__init__(None, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = '1.0.0'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        # follow azureml._restclient.clientbase.ClientBase's startegy to override
        def pretty_print(self):
            import json
            from azureml._restclient.clientbase import _ErrorEncoder
            return json.dumps(self, indent=4, cls=_ErrorEncoder)

        from azure.ml.component._restclients.designer.models import (DebugInfoResponse, InnerErrorResponse, RootError,
                                                                     ErrorResponse)
        classes_to_pretty_print = [DebugInfoResponse, InnerErrorResponse, RootError, ErrorResponse]
        for class_to_pretty_print in classes_to_pretty_print:
            class_to_pretty_print.__str__ = class_to_pretty_print.__repr__ = pretty_print

        def create_operation(operation_class):
            instance = operation_class(self._client, self.config, self._serialize, self._deserialize)
            wrap_api_caller_methods_with_error_handling(instance)
            return instance

        self.assets = create_operation(AssetsOperations)

        self.component = create_operation(ComponentOperations)

        self.components_workspace_independent = create_operation(ComponentsWorkspaceIndependentOperations)

        self.computes = create_operation(ComputesOperations)

        self.data_sets = create_operation(DataSetsOperations)

        self.experiments = create_operation(ExperimentsOperations)

        self.feeds = create_operation(FeedsOperations)

        self.models = create_operation(ModelsOperations)

        self.module = create_operation(ModuleOperations)

        self.modules = create_operation(ModulesOperations)

        self.module_with_auth = create_operation(ModuleWithAuthOperations)

        self.pipeline_component = create_operation(PipelineComponentOperations)

        self.pipeline_drafts = create_operation(PipelineDraftsOperations)

        self.pipeline_endpoints = create_operation(PipelineEndpointsOperations)

        self.pipeline_runs = create_operation(PipelineRunsOperations)

        self.published_pipelines = create_operation(PublishedPipelinesOperations)

        self.real_time_endpoints = create_operation(RealTimeEndpointsOperations)

        self.runs = create_operation(RunsOperations)

        self.samples = create_operation(SamplesOperations)

        self.computes_v2 = create_operation(ComputesV2Operations)

        self.data_sets_v2 = create_operation(DataSetsV2Operations)

        self.feeds = create_operation(FeedsOperations)

        self.feeds_v2 = create_operation(FeedsV2Operations)

        self.models = create_operation(ModelsOperations)

        self.models_v2 = create_operation(ModelsV2Operations)

        self.experiments_v2 = create_operation(ExperimentsV2Operations)

        self.models_v2 = create_operation(ModelsV2Operations)

        self.modules_v2 = create_operation(ModulesV2Operations)

        self.pipeline_drafts_v2 = create_operation(PipelineDraftsV2Operations)

        self.pipeline_endpoints_v2 = create_operation(PipelineEndpointsV2Operations)

        self.pipeline_runs_v2 = create_operation(PipelineRunsV2Operations)

        self.published_pipelines_v2 = create_operation(PublishedPipelinesV2Operations)

        self.real_time_endpoints_v2 = create_operation(RealTimeEndpointsV2Operations)

        self.runs_v2 = create_operation(RunsV2Operations)

        self.samples_v2 = create_operation(SamplesV2Operations)
